#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <bios.h>
#include <fcntl.h>
#include <string.h>
#include <memory.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <camera.h>
#include <at200.h>

void bin4x4( void );
void qlook( void );

int ems_handle;
unsigned int far *ems_page_frame;
char file_hdr[512];

main( int argc, char **argv )
{
int physical_page, logical_page;
int fh;
unsigned amtread;

if ( (ems_handle = ems_alloc( 524288L )) == 0 )
{
   printf("Unable to allocate EMS memory.\n");
   exit( 1 );
}

ems_page_frame = (unsigned int far *)ems_get_page_frame();

if ( (fh = open( argv[1], O_BINARY|O_RDONLY, S_IREAD )) == -1 )
{
   printf("Unable to open file.\n");
   exit( 1 );
}
read( fh, file_hdr, 512 );
     
for( logical_page = 0; logical_page < 8; logical_page++ ) 
{
        ems_map_page( 0, ems_handle, logical_page );
        amtread = read( fh, (char far *)ems_page_frame, 16384 );
        if ( amtread != 16384 )
        {
     	   printf ("Unable to read file data.\n" );
        }
     }
close( fh );

qlook();
}

/****************************************************************************/

void qlook( void )
{
int pbin = 2;
unsigned overhead = 0;
int width = 256;
int limit, i,j;
unsigned int far *pixel_ptr;

ems_map_page( 0, ems_handle, 3 );
ems_map_page( 1, ems_handle, 4 );

pixel_ptr = ems_page_frame + 0x2000;
pixel_ptr = pixel_ptr - (width/2)*(16/pbin - 1) - (8/pbin);
limit = 16/pbin;
for ( j = 0; j < limit; j++ )
{
	for ( i = 0; i < limit; i++ )
	{
		overhead = overhead + *pixel_ptr++;
	}
	pixel_ptr = pixel_ptr + 496/pbin;
}
printf("overhead = %u\n", overhead );
}
